/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2016 - 2018 Alberto Lara, Balthasar Weitzel
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.api.communication;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Component;

import de.fhg.iese.dd.platform.api.shared.BaseSharedTestHelper;
import de.fhg.iese.dd.platform.datamanagement.communication.model.Chat;
import de.fhg.iese.dd.platform.datamanagement.communication.model.ChatMessage;
import de.fhg.iese.dd.platform.datamanagement.communication.model.ChatParticipant;
import de.fhg.iese.dd.platform.datamanagement.communication.model.ChatSubject;
import de.fhg.iese.dd.platform.datamanagement.communication.repos.ChatMessageRepository;
import de.fhg.iese.dd.platform.datamanagement.communication.repos.ChatParticipantRepository;
import de.fhg.iese.dd.platform.datamanagement.communication.repos.ChatRepository;
import de.fhg.iese.dd.platform.datamanagement.communication.repos.ChatSubjectRepository;
import de.fhg.iese.dd.platform.datamanagement.framework.model.BaseEntity;
import de.fhg.iese.dd.platform.datamanagement.shared.push.model.PushCategory;
import de.fhg.iese.dd.platform.datamanagement.shared.push.repos.PushCategoryRepository;

@Component
public class CommunicationTestHelper extends BaseSharedTestHelper {

    @Autowired
    protected ChatRepository chatRepository;

    @Autowired
    protected ChatParticipantRepository chatParticipantRepository;

    @Autowired
    protected ChatMessageRepository chatMessageRepository;

    @Autowired
    protected ChatSubjectRepository chatSubjectRepository;

    @Autowired
    public PushCategoryRepository pushCategoryRepository;

    public Chat chat1;
    public ChatSubject chat1Subject;
    public PushCategory chat1SubjectPushCategory;
    public ChatParticipant chat1Participant1;
    public ChatParticipant chat1Participant2;
    public ChatMessage chat1Message1;
    public ChatMessage chat1Message2;
    public List<ChatMessage> chat1MessageList;

    protected Chat chat2;
    public ChatParticipant chat2Participant1;
    public ChatParticipant chat2Participant2;
    protected ChatMessage chat2Message1;
    protected List<ChatMessage> chat2MessageList;

    public Chat chat3;
    public ChatParticipant chat3Participant1;
    public ChatParticipant chat3Participant2;
    public ChatMessage chat3Message1;
    public ChatMessage chat3Message2;
    public ChatMessage chat3Message3;
    public ChatMessage chat3Message4;
    public ChatMessage chat3Message5;
    public ChatMessage chat3Message6;
    public ChatMessage chat3Message7;
    public ChatSubject chat3Subject;

    protected List<ChatMessage> chat3MessageList;

    private static <T extends BaseEntity> T reload(final JpaRepository<T, String> repository, final T entity) {
        return repository.findById(entity.getId()).orElse(null);
    }

    public void createChatEntities(){

        chat1 = chatRepository.saveAndFlush(Chat.builder()
                .topic("topic-chat-1")
                .subjects(Collections.emptySet())
                .participants(Collections.emptySet())
                .build());
        chat1Participant1 = chatParticipantRepository.saveAndFlush(ChatParticipant.builder()
                .chat(chat1)
                .person(personVgAdmin)
                .unreadMessageCount(1L)
                .build());
        chat1Participant2 = chatParticipantRepository.saveAndFlush(ChatParticipant.builder()
                .chat(chat1)
                .person(personIeseAdmin)
                .unreadMessageCount(1L)
                .build());
        chat1 = reload(chatRepository, chat1);

        chat1Message1 = chatMessageRepository.save(ChatMessage.builder()
                .sender(personVgAdmin)
                .message("Hallo Person VG Admin! - 💛 Chat Controller Test - Message 💬 1")
                .autoGenerated(false)
                .chat(chat1)
                .sentTime(nextTimeStamp() - 10)
                .build()
                .withCreated(nextTimeStamp()));

        chat1Message2 = chatMessageRepository.save(ChatMessage.builder()
                .sender(personIeseAdmin)
                .message("Hola 💬 Person IESE Admin! - 💛 Chat Controller Test - Message 2")
                .autoGenerated(false)
                .chat(chat1)
                .sentTime(nextTimeStamp() - 30)
                .build()
                .withCreated(nextTimeStamp()));

        chat1MessageList = Arrays.asList(chat1Message1, chat1Message1);
        chat1.setLastMessageNotAutoGenerated(chat1Message2);
        chat1 = chatRepository.saveAndFlush(chat1);

        chat1SubjectPushCategory = PushCategory.builder()
                .app(app1)
                .name("chat1SubjectPushCategory")
                .description("chat1SubjectPushCategory description")
                .defaultLoudPushEnabled(true)
                .configurable(true)
                .build();
        chat1SubjectPushCategory.setCreated(nextTimeStamp());
        chat1SubjectPushCategory = pushCategoryRepository.save(chat1SubjectPushCategory);

        chat1Subject = chatSubjectRepository.saveAndFlush(
                ChatSubject.builder()
                        .entityName("entityName")
                        .entityId("entityId")
                        .pushCategory(chat1SubjectPushCategory)
                        .chat(chat1)
                        .build());

        chat2 = chatRepository.saveAndFlush(Chat.builder()
                .topic("topic-chat-2")
                .subjects(Collections.emptySet())
                .build());
        chat2Participant1 = chatParticipantRepository.saveAndFlush(ChatParticipant.builder()
                .chat(chat2)
                .person(personRegularAnna)
                .unreadMessageCount(1L)
                .build());
        chat2Participant2 = chatParticipantRepository.saveAndFlush(ChatParticipant.builder()
                .chat(chat2)
                .person(personRegularKarl)
                .unreadMessageCount(1L)
                .build());
        chat2 = reload(chatRepository, chat2);

        chat2Message1 = chatMessageRepository.save(ChatMessage.builder()
                .sender(personIeseAdmin)
                .message("Do you have for me the message 💬? 💛")
                .mediaItem(createMediaItem("passion flower shirley"))
                .autoGenerated(false)
                .chat(chat2)
                .sentTime(nextTimeStamp() - 60)
                .build()
                .withCreated(nextTimeStamp()));

        chat2MessageList = List.of(chat2Message1);
        chat2.setLastMessageNotAutoGenerated(chat2Message1);
        chat2 = chatRepository.saveAndFlush(chat2);

        chat3 = chatRepository.saveAndFlush(Chat.builder()
                .topic("topic-chat-3")
                .subjects(Collections.emptySet())
                .build());

        chat3Participant1 = chatParticipantRepository.saveAndFlush(ChatParticipant.builder()
                .chat(chat3)
                .person(personRegularAnna)
                .unreadMessageCount(5L)
                .build());

        chat3Participant2 = chatParticipantRepository.saveAndFlush(ChatParticipant.builder()
                .chat(chat3)
                .person(personRegularKarl)
                .unreadMessageCount(2L)
                .build());

        chat3 = reload(chatRepository, chat3);

        chat3Subject = chatSubjectRepository.saveAndFlush(ChatSubject.builder()
                .entityName("entityName")
                .entityId("entityId")
                .pushCategory(null)
                .chat(chat3)
                .build());

        chat3Message1 = chatMessageRepository.save(ChatMessage.builder()
                .sender(personRegularKarl)
                .message("Hallo Anna, ich habe einen Bollerwagen zu anbieten")
                .autoGenerated(false)
                .chat(chat3)
                .sentTime(nextTimeStamp() - 10)
                .build()
                .withCreated(nextTimeStamp()));

        chat3Message2 = chatMessageRepository.save(ChatMessage.builder()
                .sender(personRegularKarl)
                .mediaItem(createMediaItem("Bollerwagen"))
                .autoGenerated(false)
                .chat(chat3)
                .sentTime(nextTimeStamp() - 10)
                .build()
                .withCreated(nextTimeStamp()));

        chat3Message3 = chatMessageRepository.save(ChatMessage.builder()
                .sender(personRegularKarl)
                .message("bei mir in der Pirmasenserstr. 1")
                .autoGenerated(false)
                .chat(chat3)
                .sentTime(nextTimeStamp() - 10)
                .build()
                .withCreated(nextTimeStamp()));

        chat3Message4 = chatMessageRepository.save(ChatMessage.builder()
                .sender(personRegularAnna)
                .message("Wo ist das genau? In der Nähe von Volkspark?")
                .autoGenerated(false)
                .chat(chat3)
                .sentTime(nextTimeStamp() - 10)
                .build()
                .withCreated(nextTimeStamp()));

        chat3Message5 = chatMessageRepository.save(ChatMessage.builder()
                .sender(personRegularKarl)
                .message("Nein!!! Stadtpark. Um wieviel Uhr kommst du?")
                .autoGenerated(false)
                .chat(chat3)
                .sentTime(nextTimeStamp() - 10)
                .build()
                .withCreated(nextTimeStamp()));

        chat3Message6 = chatMessageRepository.save(ChatMessage.builder()
                .sender(personRegularAnna)
                .message("Ist gegen 15Uhr OK?")
                .autoGenerated(false)
                .chat(chat3)
                .sentTime(nextTimeStamp() - 10)
                .build()
                .withCreated(nextTimeStamp()));

        chat3Message7 = chatMessageRepository.save(ChatMessage.builder()
                .sender(personRegularKarl)
                .message("Ja. Bis dann!")
                .autoGenerated(false)
                .chat(chat3)
                .sentTime(nextTimeStamp() - 10)
                .build()
                .withCreated(nextTimeStamp()));

        chat3MessageList =
                Arrays.asList(chat3Message1, chat3Message2, chat3Message3, chat3Message4, chat3Message5, chat3Message6,
                        chat3Message7);
        chat3.setLastMessageNotAutoGenerated(chat3Message7);
        chat3 = chatRepository.saveAndFlush(chat3);

        chatMessageRepository.flush();
    }

}
